/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.ui.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="U_I_TABLE_COLUMN_ORDER.BenutzerKeyAndColumnBuilderKey",
     query="SELECT o FROM UITableColumnOrder o WHERE o.columnBuilderKey = ?2 AND o.benutzerKey=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "U_I_TABLE_COLUMN_ORDER")
// @javax.persistence.IdClass(UITableColumnOrderPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class UITableColumnOrder
extends AbstractUITableColumnOrder
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public UITableColumnOrder() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public UITableColumnOrder(UITableColumnOrder original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "u_i_table_column_order_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "UITableColumnOrder")
    @javax.persistence.TableGenerator(name = "UITableColumnOrder", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "UITableColumnOrder", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient UITableColumnOrderPK pkCache;

  @Override
  public UITableColumnOrderPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new UITableColumnOrderPK(getId());
    }

    return pkCache;
  }

  public static <E extends UITableColumnOrder> java.util.Map<UITableColumnOrderPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<UITableColumnOrderPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends UITableColumnOrder> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedAnzeigen = false;
          hasChangedBenutzerKey = false;
          hasChangedColumnBuilderKey = false;
          hasChangedPosition = false;
          hasChangedColumnKey = false;
  



    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
      @javax.persistence.Column(name = "ANZEIGEN", nullable = UITableColumnOrderConstants.ANZEIGEN_NULLABLE)
    
  protected java.lang.Boolean anzeigen =  true;

  @javax.persistence.Transient
  protected boolean hasChangedAnzeigen = false;

  public boolean hasChangedAnzeigen(){
    return hasChangedAnzeigen;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertAnzeigen = false;
     @javax.persistence.Transient
     private transient java.lang.Boolean wertNachLadenAnzeigen;
  
  /**
   * 
   *
   * getter for U_I_TABLE_COLUMN_ORDER.ANZEIGEN
   */
    @Override   public  java.lang.Boolean getAnzeigen() {
        return anzeigen;
      }

  /**
   * 
   *
   * setter for U_I_TABLE_COLUMN_ORDER.ANZEIGEN
   *
   * @param anzeigen
   */
  @Override   public void setAnzeigen( java.lang.Boolean anzeigen) {

       resetTkCache();
                  java.lang.Boolean anzeigenInternal = anzeigen;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.anzeigen
      , anzeigenInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedAnzeigen |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("anzeigen");
      }


             if (!isSeitLadenVeraendertAnzeigen) {
          isSeitLadenVeraendertAnzeigen = thisAttributChanged;
         if (isSeitLadenVeraendertAnzeigen){
           wertNachLadenAnzeigen=this.anzeigen;
         }
       }
      

       this.anzeigen = anzeigenInternal;

         }

        
      @javax.persistence.Column(name = "BENUTZERKENNUNG", nullable = UITableColumnOrderConstants.BENUTZERKENNUNG_NULLABLE, length=UITableColumnOrderConstants.BENUTZERKENNUNG_MAX_LENGTH)
        
  protected java.lang.String benutzerKey =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBenutzerKey = false;

  public boolean hasChangedBenutzerKey(){
    return hasChangedBenutzerKey;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBenutzerKey = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBenutzerKey;
  
  /**
   * 
   *
   * getter for U_I_TABLE_COLUMN_ORDER.BENUTZERKENNUNG
   */
    @Override   public  java.lang.String getBenutzerKey() {
        return benutzerKey;
      }

  /**
   * 
   *
   * setter for U_I_TABLE_COLUMN_ORDER.BENUTZERKENNUNG
   *
   * @param benutzerKey
   */
  @Override   public void setBenutzerKey( java.lang.String benutzerKey) {

       resetTkCache();
                  
                          java.lang.String benutzerKeyInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(benutzerKey, UITableColumnOrderConstants.BENUTZERKENNUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.benutzerKey
      , benutzerKeyInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBenutzerKey |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("benutzerKey");
      }


             if (!isSeitLadenVeraendertBenutzerKey) {
          isSeitLadenVeraendertBenutzerKey = thisAttributChanged;
         if (isSeitLadenVeraendertBenutzerKey){
           wertNachLadenBenutzerKey=this.benutzerKey;
         }
       }
      

       this.benutzerKey = benutzerKeyInternal;

         }

        
      @javax.persistence.Column(name = "COLUMN_BUILDER", nullable = UITableColumnOrderConstants.COLUMN_BUILDER_NULLABLE, length=UITableColumnOrderConstants.COLUMN_BUILDER_MAX_LENGTH)
        
  protected java.lang.String columnBuilderKey =  null;

  @javax.persistence.Transient
  protected boolean hasChangedColumnBuilderKey = false;

  public boolean hasChangedColumnBuilderKey(){
    return hasChangedColumnBuilderKey;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertColumnBuilderKey = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenColumnBuilderKey;
  
  /**
   * 
   *
   * getter for U_I_TABLE_COLUMN_ORDER.COLUMN_BUILDER
   */
    @Override   public  java.lang.String getColumnBuilderKey() {
        return columnBuilderKey;
      }

  /**
   * 
   *
   * setter for U_I_TABLE_COLUMN_ORDER.COLUMN_BUILDER
   *
   * @param columnBuilderKey
   */
  @Override   public void setColumnBuilderKey( java.lang.String columnBuilderKey) {

       resetTkCache();
                  
                          java.lang.String columnBuilderKeyInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(columnBuilderKey, UITableColumnOrderConstants.COLUMN_BUILDER_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.columnBuilderKey
      , columnBuilderKeyInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedColumnBuilderKey |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("columnBuilderKey");
      }


             if (!isSeitLadenVeraendertColumnBuilderKey) {
          isSeitLadenVeraendertColumnBuilderKey = thisAttributChanged;
         if (isSeitLadenVeraendertColumnBuilderKey){
           wertNachLadenColumnBuilderKey=this.columnBuilderKey;
         }
       }
      

       this.columnBuilderKey = columnBuilderKeyInternal;

         }

        
      @javax.persistence.Column(name = "POSITION", nullable = UITableColumnOrderConstants.POSITION_NULLABLE, precision=UITableColumnOrderConstants.POSITION_PRECISION, scale=UITableColumnOrderConstants.POSITION_SCALE)
            
  protected java.lang.Long position =  null;

  @javax.persistence.Transient
  protected boolean hasChangedPosition = false;

  public boolean hasChangedPosition(){
    return hasChangedPosition;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertPosition = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenPosition;
  
  /**
   * 
   *
   * getter for U_I_TABLE_COLUMN_ORDER.POSITION
   */
    @Override   public  java.lang.Long getPosition() {
        return position;
      }

  /**
   * 
   *
   * setter for U_I_TABLE_COLUMN_ORDER.POSITION
   *
   * @param position
   */
  @Override   public void setPosition( java.lang.Long position) {

       resetTkCache();
                  java.lang.Long positionInternal = position;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.position
      , positionInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedPosition |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("position");
      }


             if (!isSeitLadenVeraendertPosition) {
          isSeitLadenVeraendertPosition = thisAttributChanged;
         if (isSeitLadenVeraendertPosition){
           wertNachLadenPosition=this.position;
         }
       }
      

       this.position = positionInternal;

         }

        
      @javax.persistence.Column(name = "TABLE_COLUMN", nullable = UITableColumnOrderConstants.TABLE_COLUMN_NULLABLE, length=UITableColumnOrderConstants.TABLE_COLUMN_MAX_LENGTH)
        
  protected java.lang.String columnKey =  null;

  @javax.persistence.Transient
  protected boolean hasChangedColumnKey = false;

  public boolean hasChangedColumnKey(){
    return hasChangedColumnKey;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertColumnKey = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenColumnKey;
  
  /**
   * 
   *
   * getter for U_I_TABLE_COLUMN_ORDER.TABLE_COLUMN
   */
    @Override   public  java.lang.String getColumnKey() {
        return columnKey;
      }

  /**
   * 
   *
   * setter for U_I_TABLE_COLUMN_ORDER.TABLE_COLUMN
   *
   * @param columnKey
   */
  @Override   public void setColumnKey( java.lang.String columnKey) {

       resetTkCache();
                  
                          java.lang.String columnKeyInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(columnKey, UITableColumnOrderConstants.TABLE_COLUMN_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.columnKey
      , columnKeyInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedColumnKey |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("columnKey");
      }


             if (!isSeitLadenVeraendertColumnKey) {
          isSeitLadenVeraendertColumnKey = thisAttributChanged;
         if (isSeitLadenVeraendertColumnKey){
           wertNachLadenColumnKey=this.columnKey;
         }
       }
      

       this.columnKey = columnKeyInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */

/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("UITableColumnOrder:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(UITableColumnOrder other){
                             other.anzeigen = this.anzeigen;
                                other.benutzerKey = this.benutzerKey;
                                other.columnBuilderKey = this.columnBuilderKey;
                                other.position = this.position;
                                other.columnKey = this.columnKey;
           


  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(UITableColumnOrder.class)){
        copyEntityAttributesUsingSetter((UITableColumnOrder) other.castTo(UITableColumnOrder.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von UITableColumnOrder: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(UITableColumnOrder other){
               other.setAnzeigen(this.anzeigen);
                  other.setBenutzerKey(this.benutzerKey);
                  other.setColumnBuilderKey(this.columnBuilderKey);
                  other.setPosition(this.position);
                  other.setColumnKey(this.columnKey);
       
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(UITableColumnOrder other){
                       if (hasChangedAnzeigen) {
        other.setAnzeigen(this.anzeigen);
      }
                             if (hasChangedBenutzerKey) {
        other.setBenutzerKey(this.benutzerKey);
      }
                             if (hasChangedColumnBuilderKey) {
        other.setColumnBuilderKey(this.columnBuilderKey);
      }
                             if (hasChangedPosition) {
        other.setPosition(this.position);
      }
                             if (hasChangedColumnKey) {
        other.setColumnKey(this.columnKey);
      }
             }





    @javax.persistence.Transient
    private transient UITableColumnOrderTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public UITableColumnOrderTK getUITableColumnOrderTK(){
    if (tkCache==null) {
    tkCache = new UITableColumnOrderTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getUITableColumnOrderTK();
    }

  @Override
  public UITableColumnOrderUK getUk(){
    return getUITableColumnOrderUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return UITableColumnOrder.class;
  }

public UITableColumnOrderUK getUITableColumnOrderUK(){

   return  new UITableColumnOrderUK(



  );
}

  @javax.persistence.Transient
  private transient UITableColumnOrderProperties properties;

  public UITableColumnOrderProperties getProperties(){
    if (properties == null) {
      properties = new UITableColumnOrderProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public UITableColumnOrderProperties getUITableColumnOrderProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return UITableColumnOrderConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(UITableColumnOrderConstants.MESSAGE_KEY_ANZEIGEN_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(UITableColumnOrderConstants.MESSAGE_KEY_ANZEIGEN_EINZAHL);

        anzeigen =
     vorher.getAttributTyp().getValueAsBoolean(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(UITableColumnOrderConstants.MESSAGE_KEY_BENUTZERKENNUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(UITableColumnOrderConstants.MESSAGE_KEY_BENUTZERKENNUNG_EINZAHL);

        benutzerKey =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(UITableColumnOrderConstants.MESSAGE_KEY_COLUMN_BUILDER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(UITableColumnOrderConstants.MESSAGE_KEY_COLUMN_BUILDER_EINZAHL);

        columnBuilderKey =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(UITableColumnOrderConstants.MESSAGE_KEY_POSITION_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(UITableColumnOrderConstants.MESSAGE_KEY_POSITION_EINZAHL);

        position =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

            
      if (werteVorher.containsKey(UITableColumnOrderConstants.MESSAGE_KEY_TABLE_COLUMN_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(UITableColumnOrderConstants.MESSAGE_KEY_TABLE_COLUMN_EINZAHL);

        columnKey =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertAnzeigen) {
      result.put(UITableColumnOrderConstants.MESSAGE_KEY_ANZEIGEN_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.BOOLEAN
                , wertNachLadenAnzeigen , anzeigen));
    }
                            if (isSeitLadenVeraendertBenutzerKey) {
      result.put(UITableColumnOrderConstants.MESSAGE_KEY_BENUTZERKENNUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBenutzerKey , benutzerKey));
    }
                            if (isSeitLadenVeraendertColumnBuilderKey) {
      result.put(UITableColumnOrderConstants.MESSAGE_KEY_COLUMN_BUILDER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenColumnBuilderKey , columnBuilderKey));
    }
                            if (isSeitLadenVeraendertPosition) {
      result.put(UITableColumnOrderConstants.MESSAGE_KEY_POSITION_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenPosition , position));
    }
                            if (isSeitLadenVeraendertColumnKey) {
      result.put(UITableColumnOrderConstants.MESSAGE_KEY_TABLE_COLUMN_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenColumnKey , columnKey));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertAnzeigen = false;
      wertNachLadenAnzeigen = null;
                          isSeitLadenVeraendertBenutzerKey = false;
      wertNachLadenBenutzerKey = null;
                          isSeitLadenVeraendertColumnBuilderKey = false;
      wertNachLadenColumnBuilderKey = null;
                          isSeitLadenVeraendertPosition = false;
      wertNachLadenPosition = null;
                          isSeitLadenVeraendertColumnKey = false;
      wertNachLadenColumnKey = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "U_I_TABLE_COLUMN_ORDER";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "UITableColumnOrder";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(anzeigen, this, UITableColumnOrderConstants.MESSAGE_KEY_ANZEIGEN_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(benutzerKey, this, UITableColumnOrderConstants.MESSAGE_KEY_BENUTZERKENNUNG_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(UITableColumnOrderConstants.BENUTZERKENNUNG_MAX_LENGTH , 1 ,  benutzerKey, this, UITableColumnOrderConstants.MESSAGE_KEY_BENUTZERKENNUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(columnBuilderKey, this, UITableColumnOrderConstants.MESSAGE_KEY_COLUMN_BUILDER_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(UITableColumnOrderConstants.COLUMN_BUILDER_MAX_LENGTH , 1 ,  columnBuilderKey, this, UITableColumnOrderConstants.MESSAGE_KEY_COLUMN_BUILDER_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(position, this, UITableColumnOrderConstants.MESSAGE_KEY_POSITION_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(UITableColumnOrderConstants.POSITION_MAX_VALUE, UITableColumnOrderConstants.POSITION_MIN_VALUE, position, this, UITableColumnOrderConstants.MESSAGE_KEY_POSITION_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(columnKey, this, UITableColumnOrderConstants.MESSAGE_KEY_TABLE_COLUMN_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(UITableColumnOrderConstants.TABLE_COLUMN_MAX_LENGTH , 1 ,  columnKey, this, UITableColumnOrderConstants.MESSAGE_KEY_TABLE_COLUMN_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        private transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
